# axios-factory

>  一个基于axios的小工具。经过简单的配置就可以在node项目中使用已有的http服务 
>
> 对于axios进行了简单的封装

## 快速开始

### 安装

```shell
npm i axios-factory
```

### 一个小例子

```javascript
import { AxiosFactory } from "axios-factory"

const config = {
    appConfig: {
        name: "测试app",
        auth: {
            uri: "/login",
            data: { "name": "test", "password": "123456" },
            tokenKeys: [],
        }
    },
    axiosConfig: {
        baseURL: "http://WWW.test.com"
    },
    cache: {}
}

const testApp = new AxiosFactory(
    config.appConfig,
    config.axiosConfig,
    config.cacheConfig
)

const {data} = testApp.axiosClient({url:"/news"})
console.log(data)
```

