import axios from 'axios';

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __spreadArray(to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
}

// app信息
var AxiosFactory = /** @class */ (function () {
    function AxiosFactory(config, axiosConfig, cache) {
        this.cookies = [];
        this.tokens = {};
        this.verified = false;
        this.config = config;
        this.axiosClient = this.createAxiosClient(axiosConfig);
        this.init();
    }
    AxiosFactory.prototype.init = function () {
        this.login();
    };
    AxiosFactory.prototype.login = function () {
        return __awaiter(this, void 0, void 0, function () {
            var loginConfig;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        loginConfig = {
                            url: this.config.auth.uri,
                            method: "POST",
                            data: this.config.auth.data
                        };
                        return [4 /*yield*/, this.axiosClient(loginConfig).then(function (res) {
                                _this.verified = true;
                                console.log("httpApp:".concat(_this.config.name, "\u521D\u59CB\u5316\u6210\u529F"));
                            }).catch(function (error) {
                                console.log("httpApp:".concat(_this.config.name, "\u521D\u59CB\u5316\u5931\u8D25"), error);
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    AxiosFactory.prototype.createAxiosClient = function (axiosConfig) {
        var _this = this;
        var config = __assign({ baseURL: "", withCredentials: true, timeout: 10000 }, axiosConfig);
        var api = axios.create(config);
        api.interceptors.request.use(function (config) {
            config.headers = __assign(__assign(__assign(__assign({}, config.headers), _this.config.headers), _this.tokens), { cookie: _this.cookies.join(";") });
            return config;
        });
        api.interceptors.response.use(function (response) {
            if (response.headers["set-cookie"]) {
                _this.cookies = __spreadArray(__spreadArray([], _this.cookies, true), response.headers["set-cookie"], true);
            }
            _this.config.auth.tokenKeys.forEach(function (key) {
                if (key in response.headers) {
                    _this.tokens[key] = response.headers[key];
                    console.log(key, _this.tokens[key]);
                }
            });
            return Promise.resolve(response);
        }, function (error) {
            return Promise.reject(error);
        });
        return api;
    };
    return AxiosFactory;
}());

function description() {
    return "Based on axios. After simple configuration, you can easily use the existing http service";
}
var index = {
    description: description,
    AxiosFactory: AxiosFactory
};

export { AxiosFactory, index as default, description };
//# sourceMappingURL=index.es.js.map
